const pathNode = require("path");
const fs = require("fs");
const Tool = require("./Tool");

module.exports = class FileObj {
    constructor(_path) {
        this.zipname = "";
        this.layaRoot = "";
        this.dependencies = {}; //被依赖列表
        this.dependencieNum = 0;
        this.lsdependencie = false; //是否有依赖
        this.jsonFiles = []; //ls关联依赖列表
        this.parseInfo(_path);
    }

    //获取文件buffer
    getBuffer() {
        if (!Tool.fsExistsSync(this.path)) return null;
        let buffer = fs.readFileSync(this.path, null);
        if (['ls', 'lh', 'lmat'].includes(this.ext)) {
            try {
                let json = JSON.stringify(JSON.parse(buffer.toString()));
                buffer = Buffer.from(json);
            } catch (error) {
                console.error(error);
            }
        }
        this.buffer = buffer;
        return buffer;
    }

    //获取依赖文件数量
    getDeLength() {
        return Object.keys(this.dependencies).length;
    }

    //被引用
    setDependencies(data) {
        let keyName = data.zipname + data.fileName;
        if (!this.dependencies[keyName]) {
            let depArr = {};
            depArr.zipname = data.zipname;
            depArr.fileName = data.fileName;
            this.dependencies[keyName] = depArr;
            this.lsdependencie = true;
            this.dependencieNum++;
        }
    }

    //解析文件信息
    parseInfo(_path) {
        let _arr = _path.split('/');
        let _name = _arr.pop();
        this.path = _path;
        this.dir = _arr.join('/');
        this.name = _name;
        if (_name == '') { //文件夹
            this.isDir = 1;
        } else {
            //文件
            this.isDir = 0;
            if (_name.indexOf('.lanit.ls') > -1) {
                this.ext = 'lanit.ls';
            } else if (_name.indexOf('.ltcb.ls') > -1) {
                this.ext = 'ltcb.ls';
            } else {
                this.ext = pathNode.extname(_name).replace(/^\./, "");
            }
            this.slug = _name.replace(/\./, "_");
        }
    }
}