const fs = require("fs");
const path = require("path");
const Tool = require("./Tool");

//Laya json文件解析器
class LayaJsonParse {
    constructor(fileObjs = {}) {
        this.fileList = {};
        this.fileObjs = fileObjs;
    }

    //获取依赖文件列表
    getdependencies(_path, isImg = false) {
        let node = this.getFileData(_path);
        if (node && node.data) {
            this.lsDir = this.getFileDir(_path);
            this.walkLS(node.data, isImg);
        }
        return this.fileList;
    }

    //ls lh递归解析
    walkLS(node, isImg) {
        let self = this;
        if (!node) return;
        Object.getOwnPropertyNames(node).forEach(function (key) {
            let _type = Object.prototype.toString.call(node[key]);
            if (_type == "[object String]" && node[key]) {
                // if (['clipPath'].includes(key)) {
                if (["reflection", "meshPath", "path", "clipPath", "material"].includes(key)) {
                    let tmpPath = path.posix.join(self.lsDir, node[key]);
                    tmpPath = tmpPath.replace(/\\/g, "/");
                    self.setFileObj(tmpPath);
                    if (isImg) {
                        let extname = path.extname(tmpPath).replace(/^\./, "");
                        if (extname == "lmat") {
                            self.getImgs(tmpPath);
                        }
                    }
                }
            } else {
                self.walkLS(node[key], isImg);
            }
        });
    }

    //获取材质球关联的所有图片
    getImgs(_path) {
        var node = this.getFileData(_path);
        if (node.props.textures) {
            for (let i in node.props.textures) {
                let item = node.props.textures[i];
                if (item && item.path) {
                    let tmpPath = path.posix.join(path.dirname(_path), item.path);
                    this.setFileObj(tmpPath);
                }
            }
        }
        //天空盒
        if (node.props.type == "Laya.SkyBoxMaterial" && node.props.textures[0]) {
            let ltcpath = node.props.textures[0].path;
            let tmpPath = path.posix.join(path.dirname(_path), ltcpath);
            this.setFileObj(tmpPath);
            this.getltcImgs(tmpPath);
        }
    }

    //天空盒图片
    getltcImgs(_path) {
        var node = this.getFileData(_path);
        if (node) {
            for (const name in node) {
                let png = node[name];
                let tmpPath = path.posix.join(path.dirname(_path), png);
                this.setFileObj(tmpPath);
            }
        }
    }

    //实例化
    setFileObj(tmpPath) {
        if (!this.fileList[tmpPath]) {
            this.fileList[tmpPath] = 1;
        }
    }

    //通过文件名获取文件夹
    getFileDir(_path) {
        let _arr = _path.split("/");
        _arr.pop();
        return _arr.join("/") + "/";
    }

    //获取文件内容
    getFileData(_path) {
        if (Tool.fsExistsSync(_path)) {
            let _data = fs.readFileSync(_path, "utf-8");
            _data = JSON.parse(_data);
            return _data;
        } else {
            console.error(_path + " 不存在");
        }
    }
}

module.exports = LayaJsonParse;