const fs = require("fs");
const path = require("path");

class Tool {

    //Buffer ---> ArrayBuffer
    static toArrayBuffer(buf) {
        var ab = new ArrayBuffer(buf.length);
        var view = new Uint8Array(ab);
        for (var i = 0; i < buf.length; ++i) {
            view[i] = buf[i];
        }
        return ab;
    }

    //ArrayBuffer ---> Buffer
    static toBuffer(ab) {
        return Buffer.from(ab);
    }

    //例遍文件夹
    static readDirWalk(_path, arr) {
        var files = fs.readdirSync(_path);
        files.forEach(function (item) {
            var tmpPath = path.posix.join(_path, item);
            if (tmpPath.indexOf(".svn") > -1)
                return;
            if (tmpPath.indexOf(".git") > -1)
                return;
            if (tmpPath.indexOf(".laya") > -1)
                return;
            var stats = fs.statSync(tmpPath);
            if (stats.isDirectory()) {
                Tool.readDirWalk(tmpPath, arr);
            } else {
                let extname = path.extname(tmpPath).replace(/^\./, "");
                if (['ls', 'lh', 'lmat', 'lm', 'lani'].includes(extname)) {
                    arr.push(tmpPath);
                }
            }
        });
    }

    //检测文件或者文件夹存在
    static fsExistsSync(path) {
        try {
            fs.accessSync(path, fs.F_OK);
        } catch (e) {
            return false;
        }
        return true;
    }

    //去掉首尾空格
    static trimStr(str) {
        return str.replace(/(^\s*)|(\s*$)/g, "");
    }
}

module.exports = Tool;